#include "scan_ftp.h"



int main( int argc, char* argv[] )
{

	welcome();

	if ( argc < 3 || argc > 5 ) {
		fprintf(stderr, "error , numbers arguments\n");
		return -1;
	}

	int log;
	time_t timeout = 3;


	ip_t *ip = malloc(sizeof(ip_t));

	if ( ip == NULL )
		return -1;


	if ( init_argu(argc, argv, ip, &timeout, &log) == -1 )
		return -1;

	if ( scan(ip, timeout, log) == - 1 )
		return -1;


	return 0;
}



int init_argu(const int argc, const char *argv[], ip_t *ip,  time_t *timeout, int *log)
{
	ip->ip_start = NULL;
	ip->ip_end = NULL;

	ip->ip_start = malloc(17 * sizeof(char));

	if ( ip->ip_start == NULL ) {
		fprintf(stderr, "ip_start malloc failed\n");
		return -1;
	}

	strcpy(ip->ip_start, argv[1]);

	ip->ip_end = strdup(argv[2]);

	if ( ip->ip_end == NULL ) {
		fprintf(stderr, "ip_end strdup failed\n");
		return -1;
	}

	if ( argc >= 4 )
		*timeout = atoi(argv[3]);

	if ( argc == 5 )
		log = 1;

	else
		log = 0;


	printf("** Configure successful .\n");
	return 0;
}


int scan(ip_t *ip, const time_t timeout, const int log)
{
	int nbr_ip = 0;
	int nbr_found = 0;

	printf("** Start scan .. CTRL+C for stop .\n\n");


	while ( strcmp(ip->ip_start, ip->ip_end) ) {

		socket_client_t *client = malloc(sizeof(socket_client_t));

		if ( client == NULL ) {
			fprintf(stderr, "socket_client malloc failed\n");
			return -1;
		}


		if ( socket_fonction(client, ip, timeout, log) != -1 ) {
			write_txt(ip->ip_start, 1, log);
			nbr_found++;
		}

		if ( incremente_ip(&ip->ip_start) == -1 )
			return -1;

		if ( !strcmp(ip->ip_start, ip->ip_end) ) {

			if ( socket_fonction(client, ip, timeout, log) != -1 ) {
				write_txt(ip->ip_start, 1, log);
				nbr_found++;
			}
			nbr_ip++;
		}


		socket_client_free(client);
		nbr_ip++;
	}


	printf("** Scan finish .\n");
	printf("** Numbers ip's scanned : %d .\n", nbr_ip);
	printf("** Numbers anonymous session find : %d .\n\n", nbr_found);

	ip_free(ip);

	return 0;

}



int socket_fonction(socket_client_t *client, ip_t *ip, const time_t timeout, const int log)
{

	if ( socket_client_new(client, ip->ip_start) == -1 )
		return -1;

	if ( socket_client_connect(client, timeout) == -1 )
		return -1;


	if ( test_passwd(client, timeout) == -1 ) {
		write_txt(ip->ip_start, 0, log);
		return -1;
	}

	else
		return 0;

}


void write_txt(const char *ip, const int mod, const int log)
{
	if ( mod ) {
		printf("Ip \r\t\t: %s\nPort \r\t\t: 21\nEtat \r\t\t: Open\n", ip);
		printf("Anonymous \r\t\t: Accept\n\n");

		if ( log ) 
			write_file_log(ip);

	}

	else if ( !mod ) {
		printf("Ip \r\t\t: %s\nPort \r\t\t: 21\nEtat \r\t\t: Open\n", ip);
		printf("Anonymous \r\t\t: Refus\n\n");
	}

}


void write_file_log(const char *ip)
{
	FILE *file_log = NULL;

	file_log = fopen(LOG, "r");

	if ( file_log == NULL )
		creat_new_log();

	else
		fclose(file_log);

	file_log = fopen(LOG, "a");

	fprintf(file_log, "Ip \t\t: %s\nPort \t\t: 21\nEtat \t\t: Open\nAnonymous \t: Accept\n\n", ip);
	
	fclose(file_log);
}


void creat_new_log(void)
{
	FILE *file_log = NULL;

	file_log = fopen(LOG, "w");

	fprintf(file_log, ACL);

	fclose(file_log);

}



int test_passwd(socket_client_t *client, const time_t timeout)
{

	char *buff = NULL;
	buff = malloc( 1000 * sizeof(char));

	if ( buff == NULL )
		return -1;

	sleep(1);

	if ( socket_client_send_packet(client, USER) == -1 )
		return -1;

	sleep(1);

	if ( socket_client_send_packet(client, PASS) == -1 )
		return -1;


	if ( socket_client_recv_packet(client, &buff, timeout) == -1 )
		return -1;

	if ( check_succefull(buff) == -1 )
		return -1;


	free(buff);
	return 0;
}



int check_succefull(const char *ident_recv)
{
	char *search = NULL;

	search = strtok(ident_recv, "-");

	while ( search != NULL ) {

		if ( strstr(search, "230") != NULL )
			return 0;

		search = strtok(NULL, "\n");

	}

	return -1;
}


int incremente_ip(char **ip)
{
	int i = 0;
	int tab_ip[4] = {0};
	char *buff = NULL;
	char *copy = NULL;


	copy = strdup(*ip);
	if ( copy == NULL ) {
		fprintf(stderr, "erreur stdup copy\n");
		return -1;
	}

	buff = strtok(copy, ".");
	while ( buff != NULL ) {

		tab_ip[i] = atoi(buff);
		buff = strtok(NULL, ".");

		i++;
	}


	if ( tab_ip[0] == 255 )
		return 1;

	if ( tab_ip[1] == 255 ) {
		tab_ip[0]++;
		tab_ip[1] = 0;
	}

	if ( tab_ip[2] == 255 ) {
		tab_ip[1]++;
		tab_ip[2] = 0;
	}

	if ( tab_ip[3] == 255 ) {
		tab_ip[2]++;
		tab_ip[3] = -1;
	}

	tab_ip[3]++;

	memset(*ip, 0, sizeof(*ip));

	sprintf(*ip, "%d.%d.%d.%d", tab_ip[0], tab_ip[1], tab_ip[2], tab_ip[3]);

	free(copy);
	return 0;
}


void ip_free(ip_t *ip)
{

	if ( ip != NULL ) {

		if ( ip->ip_end != NULL )
			free(ip->ip_end);

		if ( ip->ip_start != NULL )
			free(ip->ip_start);

		free(ip);
		ip = NULL;
	}
}


void welcome(void)
{
	fprintf(stdout, "\n\t\t --- Scanner of anonymous session FTP ---\n\t\tCoded : simpp ( # Bad Digites Team # )\n");
	fprintf(stdout, "\t\t Read README.txt for more information\n\n");
	fprintf(stdout, "** Configure paramet's ...\n");
}
