#include "scan_ftp.h"



int
socket_client_new(socket_client_t *client, const char *ip)
{
	client->socket_cli = socket(AF_INET, SOCK_STREAM, 0);
	if ( client->socket_cli == -1 ) {
		fprintf(stderr, "socket_cli socket() failed\n");
		return -1;
	}

	client->to.sin_family = AF_INET;
	client->to.sin_port = htons(PORT);
	client->to.sin_addr.s_addr = inet_addr(ip);

	return 0;

}


int
socket_client_connect(socket_client_t *client, const time_t timeout)
{
	int ret, retval;
	fd_set set_exec;

	struct timeval tv;

	tv.tv_sec = timeout;
	tv.tv_usec = 0;

	FD_ZERO(&set_exec);
	FD_SET(client->socket_cli, &set_exec);


	fcntl(client->socket_cli, F_SETFL, O_NONBLOCK);

	connect(client->socket_cli, (struct sockaddr *)&client->to, sizeof(client->to));

	retval = select(1, NULL, NULL, &set_exec, &tv);

	ret = connect(client->socket_cli, (struct sockaddr *)&client->to, sizeof(client->to));

	if ( retval < 0 )
		return -1;


	if ( ret == -1 )
		return -1;

	if ( retval > 0 )
		return 0;


}



int
socket_client_recv_packet(socket_client_t *client, char **buff, const time_t timeout)
{
	int ret;

	sleep(timeout);
	memset(*buff, 0, sizeof(*buff));


	ret = read(client->socket_cli, *buff, 1000);

	if ( ret == -1 )
		return -1;

	return 0;
}


int
socket_client_send_packet(socket_client_t *client, const char *buff)
{
	int ret;

	ret = write(client->socket_cli, buff, strlen(buff));

	if ( ret == -1 )
		return -1;

	return 0;
}


void
socket_client_free(socket_client_t *client)
{
	if ( client != NULL ) {

		if ( client->socket_cli != -1 )
			close(client->socket_cli);

		free(client);
		client = NULL;
	}
} 
